recipes/config/routes.rb
Rails.application.routes.draw do
  devise_for :users, controllers: {registrations: 'registrations'}

  resources :users, only: [:show] do
    member do
      post 'create_favorite'
      delete 'delete_favorite'
    end
  end

  resources :recipes do
    member do
      get 'send_to_friend', as: :send_to_friend
      post 'mail_to_friend', as: :mail_to_friend
    end
  end

  resources :food_preferences, only: [:show, :new, :create]
  resources :food_types, only: [:show, :new, :create]
  resources :kitchens, only: [:show, :new, :create]
  root 'recipes#index'

end

recipes/app/models/recipe.rb
class Recipe < ActiveRecord::Base
  validates :name, length: { maximum: 30, too_long: 'The name is too long.' }
  validates :name, presence: {message: 'Must give a recipe name.'}
  validates :ingredients, presence: {message: "Must fill in the recipe\'s ingredients"}
  validates :preparation, presence: {message: "Must fill in the recipe\'s preparation"}
  validates_associated :kitchen, presence: {message: 'Must give a recipe kitchen.'}
  validates_associated :food_type, presence: {message:"Must specify the recipe\'s food type"}
  validates_associated :food_preference, presence: {message: "Must specify the recipe\'s food preference"}

  has_many :recipes_users, dependent: :destroy
  has_many :tasters, through: :recipes_users, source: :user

  belongs_to :user
  belongs_to :food_preference
  belongs_to :food_type
  belongs_to :kitchen

  has_attached_file :photo
  validates_attachment_content_type :photo, :content_type => %w(image/jpeg image/jpg image/png)


  scope :last_recipes, ->{ all.order(created_at: :desc).limit(20) }
  scope :most_favorites, ->{ where.not(tasters_count: 0).order(tasters_count: :desc).limit(20) }
  DIFFICULTIES = %w(easy medium hard).freeze

  def self.difficulties
    DIFFICULTIES
  end

end

recipes/app/controllers/recipes_controller.rb
class RecipesController < ApplicationController
  before_action :authenticate_user!, except: [:show, :index]
  before_action :get_recipe, only: [:edit, :update, :destroy]
  def index
    @last_recipes = Recipe.last_recipes.decorate
    @favorites = Recipe.most_favorites.decorate
  end

  def new
    @recipe = Recipe.new
  end

  def create
    @recipe = current_user.recipes.create recipe_params
    respond_with @recipe
  end

  def show
    @recipe = Recipe.find(params[:id]).decorate
  end

  def edit
  end

  def update
    @recipe.update recipe_params
    respond_with @recipe
  end

  def destroy
    @recipe.destroy
    redirect_to user_path(current_user)
  end

  def mail_to_friend
    @recipe = Recipe.find(params[:id])
    @user = User.find_by(email: params[:email])
    RecipeMailer.send_recipe_to_friend( @recipe, @user.email ).deliver
    redirect_to @recipe
  end

  def send_to_friend
    @recipe = Recipe.find(params[:id])
  end

  private

  def get_recipe
    @recipe = Recipe.find params[:id]
  end

  def recipe_params
    params.require(:recipe)
          .permit(:name, :kitchen_id, :food_type_id, :food_preference_id,
                  :total_people, :total_time, :difficulty, :ingredients,
                  :preparation, :photo)
  end
end

recipes/app/views/recipes/_form.html.erb
<section class='col-md-4 col-xs-12'>
  <div class='errors alert'>
    <% if @recipe.errors.any? %>
    <ul>
      <% @recipe.errors.full_messages.each do |err| %>
        <li><%= err %></li>
      <% end %>
    </ul>
    <% end %>
  </div>
  <div class='form'>
  <%= form_for @recipe do |f| %>
    <div class='field form-group'>
      <%= f.label :name %>
      <%= f.text_field :name, class:'form-control' %>
    </div>

    <div class='field form-group'>
      <%= f.label :kitchen_id %>
      <%= f.collection_select :kitchen_id, @kitchens, :id, :name, class:'form-control' %>
    </div>

    <div class='field form-group'>
      <%= f.label :food_type_id %>
      <%= f.collection_select :food_type_id, @food_types, :id, :name, class:'form-control' %>
    </div>

    <div class='field form-group'>
      <%= f.label :food_preference_id %>
      <%= f.collection_select :food_preference_id, @food_preferences, :id, :name, class:'form-control' %>
    </div>

    <div class='field form-group'>
      <%= f.label :total_time %>
      <%= f.text_field :total_time, class:'form-control' %>
    </div>

    <div class='field form-group'>
      <%= f.label :total_people %>
      <%= f.text_field :total_people, class:'form-control' %>
    </div>

    <div class='field form-group'>
      <%= f.label :difficulty %>
      <%= f.collection_select :difficulty, Recipe.difficulties, :to_s, :to_s, class:'form-control' %>
    </div>

    <div class='field form-group'>
      <%= f.label :ingredients %>
      <%= f.text_area :ingredients, class:'form-control' %>
    </div>

    <div class='field form-group'>
      <%= f.label :preparation %>
      <%= f.text_area :preparation, class:'form-control' %>
    </div>

    <div class='field form-group'>
      <%= f.label :photo %>
      <%= f.file_field :photo, class:'form-control' %>
    </div>

    <div class='field form-group'>
      <%= f.submit message, class:'btn btn-default' %>
    </div>
  <%end%>
  </div>
</section>

recipes/app/views/recipes/_recipe.html.erb
<article class='recipe recipe-description'>
  <div class='full-recipe'>
    <div class='header'>
      <h4 class='recipe-title col-md-12' style='font-size: 2em'>
        <%= link_to recipe.name, recipe %>
        <span class='glyphicon glyphicon-thumbs-up badge'> <%=recipe.tasters_count%></span>
      </h4>
      <p>
        <em>Enviado por <%= link_to recipe.user.name, user_path(recipe.user) %></em>
        <%= recipe.as_favorite %>
      </p>
      <hr>
    </div>
  <div class='row'>
    <div class='recipe-image image-responsive col-sm-6'>
      <%= image_tag recipe.photo, id: 'recipe-photo' %>
    </div>
    <%= render partial: 'recipes/recipe_data', locals:{recipe: recipe} %>
  </div>
  <hr>
  <div class='row'>
    <div class='recipe-ingredients col-md-6'>
      <em>Ingredientes: </em>
      <p><%= recipe.ingredients %></p>
    </div>
    <div class='recipe-body col-md-6'>
      <em>Passo a passo: </em>
      <p><%= recipe.preparation %></p>
    </div>
  </div>

  <%= recipe.editable %>
  <%= recipe.email_to %>
  <hr>
  </div>
</article>

recipes/app/views/recipes/_recipe_brief.html.erb
<article class='recipe recipe-brief'>
  <h4 class='recipe-title col-md-12'>
    <%= link_to recipe_brief.name, recipe_brief %>
    <span class='glyphicon glyphicon-thumbs-up badge'> <%=recipe_brief.tasters_count%></span>
  </h4>
  <%= recipe_brief.as_favorite %>
    <div class='row'>
    <div class='recipe-image image-responsive col-sm-6'>
      <%= image_tag recipe_brief.photo, id: 'recipe-photo' %>
    </div>
    <%= render partial:'recipes/recipe_data', locals:{recipe: recipe_brief} %>
  </div>
  <hr>
</article>

recipes/app/views/recipes/_recipe_data.html.erb
<div class='recipe-data'>
  <p><em>Dificuldade: </em><%= recipe.difficulty %></p>
  <p><em>Cozinha: </em><%= recipe.kitchen.name %></p>
  <p><em>Tipo de comida: </em><%= recipe.food_type.name %></p>
  <p><em>Preferência: </em><%= recipe.food_preference.name %></p>
  <p><em>Tempo total: </em><%= recipe.total_time %> minutos</p>
  <p><em>Pessoas servidas: </em><%= recipe.total_people %> pessoas</p>
</div>

recipes/app/views/recipes/edit.html.erb
<%= render partial: 'form', locals: {message: 'Salvar alterações'} %>

recipes/app/views/recipes/index.html.erb
<%= render partial: 'shared/show_recipes', locals: {
  last_recipes: @last_recipes, favorites: @favorites
} %>

recipes/app/views/recipes/new.html.erb
<%= render partial: 'form', locals: {message: 'Criar receita'} %>

recipes/app/views/recipes/send_to_friend.html.erb
<%= render partial:'recipe_brief', collection: @recipe %>
<section class='col-md-4'>
  <%= form_tag mail_to_friend_recipe_path, {method: :post, class:'form'} do %>
    <div class='form-group'>
      <%= label_tag :email %>
      <%= email_field_tag :email, nil, class:'form-control'%>
    </div>
    <div class='form-group'>
      <%= submit_tag 'Enviar', class:'btn btn-default' %>
    </div>
  <% end %>
</section>

recipes/app/views/recipes/show.html.erb
<%= render @recipe %>